' {$STAMP BS1}
DIRS = %00000000
LOW 7             'az motor
LOW 6             'H-bridge polarity
LOW 5             'el motor
LOW 2             ' cal power

Main:
W2 = 0
B2 = 0
SERIN 0,N2400,("move"),#B8,#W5
'b8=2
'w5=100
'b8=1
'debug b8,w5
BRANCH B8, (M1CW,M1CCW,M2CW,M2CCW,CALOUT,CALIN,NCALOFF,NCALON)
SEROUT 1,N2400,("E ",#B8," ",#W5,13)
DIR1 = 0                                       'open output
GOTO Main

Pulse1:

 IF PIN3 = 0 THEN Ps1
 B2 = 1                        'starts in next sw zone
Ps1:
 HIGH 7                        'turn on motor
Pls1:
  PULSIN 3,1,W0
  IF W0=0 THEN Tm1
    W2=W2+1
  IF W2<W5 THEN Pls1
  LOW 7                          'turn off motor
  GOTO Pls1
Tm1:
  IF W2<W5 THEN Timeout
  IF PIN3 = 0 THEN MOUT
  B2=B2+1                        'passed to next sw zone add one
GOTO MOUT


Pulse2:

 IF PIN4 = 0 THEN Ps2
 B2 = 1
Ps2:
  HIGH 5
Pls2:
  PULSIN 4,1,W0
  IF W0=0 THEN Tm2
    W2=W2+1
 IF W2<W5 THEN Pls2
 LOW 5
 GOTO Pls2
Tm2:
  IF W2<W5 THEN Timeout
  IF PIN4 = 0 THEN MOUT
  B2=B2+1

MOUT:

  SEROUT 1,N2400,("M ",#W2," ",#B2," ",#B8,13)
  DIR1 = 0
  GOTO Main

M2CW:

  LOW 6
  GOTO Pulse2

M2CCW:

  HIGH 6
  GOTO Pulse2

M1CW:

  LOW 6
  GOTO Pulse1

M1CCW:

  HIGH 6
  GOTO Pulse1

Timeout:

  PAUSE 50
  SEROUT 1,N2400,("T ",#W2," ",#B8," ",#W5,13)
  DIR1 = 0
  W5=0
  LOW 7
  LOW 6
  LOW 5
  GOTO Main

NCALOFF:

 LOW 2
 GOTO Sout

 NCALON:

 HIGH 6
 HIGH 2
 GOTO Sout

 CALIN:
 LOW 6
 HIGH 2
 PAUSE 20000
 LOW 2
 GOTO Sout

 CALOUT:

 HIGH 6
 HIGH 2
 PAUSE 20000
 LOW 2
 GOTO Sout

 Sout:

 SEROUT 1,N2400,("C ",#W2," ",#B8," ",#W5,13)
 DIR1=0
 GOTO Main